(provide 'uwu)

(load "~/hobbies/uwu/version-1/uwu-graphics.el")

(defvar uwu-mode-map
  (let ((map (make-sparse-keymap)))
    ;; scroll back one pet, inside the pet viewer
    (define-key map (kbd "a") #'uwu--previous-pet)
    (define-key map (kbd "s") #'uwu--next-pet)
    map)
  "Keymap for `uwu-mode'.")

(defgroup uwu nil
  "A virtual pet simulator."
  :group 'applications)

(defcustom uwu-mode-hook nil
  "Hook run when entering uwu mode."
  :type 'hook
  :group 'uwu)

(define-derived-mode uwu-mode fundamental-mode "uwu"
  "The major mode of the uwu virtual pet simulator")

(defvar *pet-shop-choice* nil)

(defun pet-movement (pet-gfx)

  (let ((rng-move (random 5)))

    (cond ((and (= 3 rng-move) (> movement 0)) (decf movement))
	  ((and (= 4 rng-move) (< movement 9)) (incf movement)))

    (print
     (concat
      (substring "         " movement)
      (nth rng-move pet-gfx))
     (get-buffer "*scratch*"))))

(defun blank-and-draw-frame ()
  (set-buffer "*scratch*")
  (erase-buffer)
  (pet-movement ))